;
;  Generalized UCDOS 3.0 Printer Escape Sequence Definitions
;
ifndef IN_DBASE
page 66,132
endif

include printer.def

ifndef IN_DBASE
segstart macro
code    segment
        assume  cs:code,ds:code
        org     0000h
endm

segend  macro
code    ends
        end
endm

else

segstart macro
endm

segend  macro
endm

endif

seq macro sname,ssize,sstr
        local $sname
        sname   db      $sname - $ - 1
        ifnb <sstr>
                        db      sstr
        endif
        $sname          db      ssize - ($ - sname) dup (0)
endm
;
segstart
;
drv_id          db      "DB42_0C "      ; product
drv_name        db      "UCDOS3  "      ; 8 letter driver name.
drv_pad         db      0dh, 0ah, 1ah   ; cr, lf, eof

; ======================> TEXT PRINTING DATA <==========================
;
prt_first_tab_size      db      00h
prt_cur_attr            db      00h
;
prt_eol_override        db      00h
; Inversed, Superscript and Subscript escape seq must be on the same line
prt_attr_on_same_line	db	02h+08h+10h
prt_compress_override   db      00h
prt_elite_override      db      00h
prt_nlq_override        db      00h
;
attr_strings:
; The size of all these strings must be equal to ATTR_STR_SIZE above.
; BOLD =prt_cur_attr bit0
seq     prt_bold_set            ATTR_STR_SIZ	<0>
seq     prt_bold_clear          ATTR_STR_SIZ	<0>

; REVERSE = prt_cur_attr bit1
seq     prt_reverse_set         ATTR_STR_SIZ	<CTRL,'%7',CTRL>
seq     prt_reverse_clear       ATTR_STR_SIZ	<CTRL,'%0',CTRL>

; UNDERLINE  =prt_cur_attr bit2
seq     prt_underline_set       ATTR_STR_SIZ	<CTRL,'_','1',CTRL>
seq     prt_underline_clear     ATTR_STR_SIZ	<CTRL,'_','0',CTRL>

; SUPERSCRIPT = prt_cur_attr bit3
seq    prt_superscript_set      ATTR_STR_SIZ	<CTRL,':','1',CTRL>
seq    prt_superscript_clear    ATTR_STR_SIZ	<CTRL,':','0',CTRL>

; SUBSCRIPT  =prt_cur_attr bit4
seq    prt_subscript_set        ATTR_STR_SIZ	<CTRL,':','2',CTRL>
seq    prt_subscript_clear      ATTR_STR_SIZ	<CTRL,':','0',CTRL>

; NEAR LETTER QUALITY  =prt_cur_attr bit5
seq     prt_nlq_set             ATTR_STR_SIZ	<CTRL,';'>
seq     prt_nlq_clear           ATTR_STR_SIZ	<'=',CTRL>

; CONDENSE PITCH  =prt_cur_attr bit6
; Set 15 CPI Compress on  ( condense mode )
; 3/120" spacing.
seq     prt_compress_set        ATTR_STR_SIZ	<0>
seq     prt_compress_clear      ATTR_STR_SIZ	<0>

; PICA PITCH
; Set 10 CPI ( HD pica mode )
seq     prt_cpi10_set           16	<0>

; ELITE PITCH
; Set 12 CPI ( elite mode )
; 1*2 dot spacing, so we must send sequence before EVERY character.
; 3/20" width.
seq     prt_cpi12_set           16	<0>

; GENERIC PITCH
seq     prt_cpi_set             16	<0>

; INITIALIZE THE PRINTER (everything!)
; redefine esc code size (16->20)
seq     prt_init                20      <CTRL,':0',CTRL,CTRL,'@','A',CTRL>

; DEINITIALIZE THE PRINTER (everything!)
; redefine esc code size (16->20)
seq     prt_deinit              20      <CTRL,':0',CTRL,CTRL,'@','A',CTRL>

;
seq     prt_set_first_tab_stop  8

;
seq     prt_eol_no_lf           8       <CR>
;
seq     prt_eol                 8       <CR,LF>
;
seq     prt_formfeed            8       <FF>
;
; SHEETFEED
seq     prt_sheetfeed           16      <CR, FF>

;
seq     prt_cancel_reset        16      <CTRL,':0',CTRL>

; f0
; POSTSCRIPT STRINGS
pst_text_begin          label   byte            ; Postscript start text
seq     prt_color_set           8

pst_text_end            label   byte            ; Postscript end text
seq     prt_black_set           8
;
; ======================> GRAPHIC PRINTING DATA <==========================
;
prt_ypixels_per_char    dw      1       ; 16 or 24
prt_msb_top             db      0       ; 0 - MSB of image data byte is top
                                        ; 1 - MSB of image data byte is bottom
prt_pincount            db      24      ; 24 or 16 pins?
prt_stat                dw      0       ; only tells if POSTSCRIPT or not.
;
; Line Feed adjustment control strings.
;
; Small CR & LF 10/120"
seq     prt_short_lf_set        8

; Normal CR & LF 20/120 = 1/6"
seq     prt_short_lf_clear      8

; ==================== PRT_CHAR_XLAT_TBL =======================
; This table maps each character into a byte value.  This is used for
; "user text" only, not for printer control strings or @ST arguments.
;
; This default table is the full 8-bit pass-thru.  We decided that
; the normal user has some brain activity and can handle this.

                   public       prt_char_xlat_tbl
prt_char_xlat_tbl       label   byte

        db      00h, 01h, 02h, 03h, 04h, 05h, 06h, 07h  ; 00 - 07
        db      08h, 09h, 0Ah, 0Bh, 0Ch, 0Dh, 0Eh, 0Fh  ; 08 - 0F
        db      10h, 11h, 12h, 13h, 14h, 15h, 16h, 17h  ; 10 - 17
        db      18h, 19h, 1Ah, 1Bh, 1Ch, 1Dh, 1EH, 1FH  ; 18 - 1f
        db      ' ', '!', '"', '#', '$', '%', '&', 27h  ; 20 - 27
        db      '(', ')', '*', '+', ',', '-', '.', '/'  ; 28 - 2f
        db      '0', '1', '2', '3', '4', '5', '6', '7'  ; 30 - 37
        db      '8', '9', ':', ';', '<', '=', '>', '?'  ; 38 - 3f
        db      '@', 'A', 'B', 'C', 'D', 'E', 'F', 'G'  ; 40 - 47
        db      'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O'  ; 48 - 4F
        db      'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W'  ; 50 - 57
        db      'X', 'Y', 'Z', '[', '\', ']', '^', '_'  ; 58 - 5f
        db      '`', 'a', 'b', 'c', 'd', 'e', 'f', 'g'  ; 60 - 67
        db      'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o'  ; 68 - 6f
        db      'p', 'q', 'r', 's', 't', 'u', 'v', 'w'  ; 70 - 77
        db      'x', 'y', 'z', '{', '|', '}', '~', 7FH  ; 78 - 7f
        db      80h, 81h, 82h, 83h, 84h, 85h, 86h, 87h  ; 80 - 87
        db      88h, 89h, 8Ah, 8Bh, 8Ch, 8Dh, 8Eh, 8Fh  ; 88 - 8f
        db      90h, 91h, 92h, 93h, 94h, 95h, 96h, 97h  ; 90 - 97
        db      98h, 99h, 9Ah, 9Bh, 9Ch, 9Dh, 9Eh, 9Fh  ; 98 - 9f
        db      0A0h,0A1h,0A2h,0A3h,0A4h,0A5h,0A6h,0A7h ; a0 - a7
        db      0A8h,0A9h,0AAh,0ABh,0ACh,0ADh,0AEh,0AFh ; a8 - af
        db      0B0h,0B1h,0B2h,0B3h,0B4h,0B5h,0B6h,0B7h ; b0 - b7
        db      0B8h,0B9h,0BAh,0BBh,0BCh,0BDh,0BEh,0BFh ; b8 - bf
        db      0C0h,0C1h,0C2h,0C3h,0C4h,0C5h,0C6h,0C7h ; c0 - c7
        db      0C8h,0C9h,0CAh,0CBh,0CCh,0CDh,0CEh,0CFh ; c8 - cf
        db      0D0h,0D1h,0D2h,0D3h,0D4h,0D5h,0D6h,0D7h ; d0 - d7
        db      0D8h,0D9h,0DAh,0DBh,0DCh,0DDh,0DEh,0DFh ; d8 - df
        db      0E0h,0E1h,0E2h,0E3h,0E4h,0E5h,0E6h,0E7h ; e0 - e7
        db      0E8h,0E9h,0EAh,0EBh,0ECh,0EDh,0EEh,0EFh ; e8 - ef
        db      0F0h,0F1h,0F2h,0F3h,0F4h,0F5h,0F6h,0F7h ; f0 - f7
        db      0F8h,0F9h,0FAh,0FBh,0FCh,0FDh,0FEh,0FFh ; f8 - ff

;* @np
; ==================== PRT_MULTIBYTE_CHAR_TBL =======================
; If a FFh is the result of the prt_char_xlat_tbl, then this table is
; used to generate a multi-byte sequence for the original char.
;
; The prt_multibyte_char_tbl is organized as a 32 x 4-byte table.
; The first byte is used as an index for the original user character.
; Whenever a match is found, the remaining three characters are output.
; The entire table is always searched; this allows for multiple sequences
; to be output for the same character.
; Note: If no matches are found, a FFh is output.
;

                             public     prt_multibyte_char_tbl
prt_multibyte_char_tbl  db      128 dup (0)     ; 32 x 4

; This global used by code to load table
;
segend
